"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.getMemoizeHoc = void 0;

var _pick2 = _interopRequireDefault(require("lodash/pick"));

var _compact2 = _interopRequireDefault(require("lodash/compact"));

var _uniq2 = _interopRequireDefault(require("lodash/uniq"));

var _react = require("react");

var _createReactContext2 = _interopRequireDefault(require("create-react-context"));

var _bitsObserver2 = _interopRequireDefault(require("./bitsObserver"));

var _db = _interopRequireDefault(require("../db"));

var _cacheUtil = require("../cache-util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getMemoizeHoc = function getMemoizeHoc(VanConsumer) {
  return function (propKeys, mapFunc) {
    propKeys = (0, _uniq2.default)((0, _compact2.default)(propKeys));
    return function (BaseComponent) {
      return function (props) {
        return (0, _react.createElement)(VanConsumer, props, function (db) {
          var dataProps = mapFunc && db.memoize(mapFunc, (0, _pick2.default)(props, propKeys), props);
          return (0, _react.createElement)(BaseComponent, _objectSpread({}, props, {
            db: db
          }, dataProps));
        });
      };
    };
  };
};

exports.getMemoizeHoc = getMemoizeHoc;

var createDatavanContext = function createDatavanContext(config) {
  var _bitsObserver = (0, _bitsObserver2.default)(config),
      calcChangedBits = _bitsObserver.calcChangedBits,
      getObservedBits = _bitsObserver.getObservedBits;

  var _createReactContext = (0, _createReactContext2.default)(null, calcChangedBits),
      Provider = _createReactContext.Provider,
      Consumer = _createReactContext.Consumer;

  var VanProvider =
  /*#__PURE__*/
  function (_Component) {
    _inherits(VanProvider, _Component);

    function VanProvider(props) {
      var _this;

      _classCallCheck(this, VanProvider);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(VanProvider).call(this, props)); // TODO may pass upper provider db instead of config here

      var db = props.initDb ? props.initDb(config) : props.db || (0, _db.default)(config);
      _this.state = db;
      return _this;
    }

    _createClass(VanProvider, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var _this2 = this;

        this.unsubscribe = this.state.subscribe(function (change) {
          return _this2.setState(change);
        });
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.unsubscribe();
      }
    }, {
      key: "render",
      value: function render() {
        return (0, _react.createElement)(Provider, {
          value: this.state
        }, this.props.children);
      }
    }]);

    return VanProvider;
  }(_react.Component);
  /* eslint-disable react/no-multi-comp */


  var VanConsumer =
  /*#__PURE__*/
  function (_Component2) {
    _inherits(VanConsumer, _Component2);

    function VanConsumer() {
      var _getPrototypeOf2;

      var _temp, _this3;

      _classCallCheck(this, VanConsumer);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _possibleConstructorReturn(_this3, (_temp = _this3 = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(VanConsumer)).call.apply(_getPrototypeOf2, [this].concat(args))), _defineProperty(_assertThisInitialized(_assertThisInitialized(_this3)), "observedBits", getObservedBits(_this3.props.observe)), _defineProperty(_assertThisInitialized(_assertThisInitialized(_this3)), "memoizer", (0, _cacheUtil.createBatchMemoizer)(function () {
        return _this3.setState({
          cacheAt: Date.now()
        });
      })), _temp));
    }

    _createClass(VanConsumer, [{
      key: "UNSAFE_componentWillReceiveProps",
      // eslint-disable-next-line
      value: function UNSAFE_componentWillReceiveProps(nextProps) {
        if (this.props.observe !== nextProps.observe) {
          this.observedBits = getObservedBits(nextProps.observe);
        }
      }
    }, {
      key: "render",
      value: function render() {
        var _this4 = this;

        var props = this.props;
        return (0, _react.createElement)(Consumer, _objectSpread({}, props, {
          observedBits: this.observedBits
        }), function (db) {
          return props.children(_this4.memoizer.newBatch(db));
        });
      }
    }]);

    return VanConsumer;
  }(_react.Component);

  Object.assign(VanConsumer, {
    Provider: VanProvider,
    config: config,
    hoc: function hoc(propKeys, mapFunc) {
      return getMemoizeHoc(VanConsumer)(propKeys, mapFunc);
    }
  });
  return VanConsumer;
};

var _default = createDatavanContext;
exports.default = _default;